unit uWMCopyDataSender;

{******************************************************************************
Initial Author   :    Scott Price
Initially Created:    06-Apr-2003
Language         :    Object Pascal
Compiler Version :    Delphi 3.02, 4.03, 5.01, 6.02 (UK)
Copyright        :     Information Technology Sector Limited, 1996-2002

Source Code Constraints:
========================
   Distribution, disclosure or modifications of this source code, outside of
   any licenced agreements with Information Technology Sector Limited, or
   removal of this notice constitutes a breach of any or all license agreements.

Operating Systems Tested On:
============================
   Microsoft Windows(R) 98, First Edition
   Microsoft Windows(R) 2000, Service Pack 2

Design Notes:
=============

VERSION  AUTHOR                DATE/TIME
===============================================================================
$history$
$nokeywords$
===============================================================================
NOTES:
 - This Process-object will send another objects information to another
   Process-object for it to process, streaming the component object, and then
   WM_COPYDATA the stream to the destination.
===============================================================================
TODO:
 - Receiver:
procedure WMCopyData(var Msg: TWMCopyData); message WM_COPYDATA;
begin
  Move(recPrint^, FCurrentJob^, Msg.CopyDataStruct^.cbData);
end;
******************************************************************************}


interface



uses
  { Borland Standard Units }
{$IFDEF VER140}
  Variants,
{$ENDIF}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

  
type
  { TfmWMCopyDataSender }
  
  TfmWMCopyDataSender = class(TForm)
    btnPressMe: TButton;
    btnSendPressMe: TButton;
    procedure btnSendPressMe_OnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  

var
  fmWMCopyDataSender: TfmWMCopyDataSender;



implementation



{$R *.dfm}

procedure TfmWMCopyDataSender.btnSendPressMe_OnClick(Sender: TObject);
var
  msOut: TMemoryStream;
  hTarget: THandle;
  rCopyDat: TCopyDataStruct;
begin
    hTarget := FindWindow('TfmWMCopyDataReceiver', Nil);
    if hTarget <> 0 then
    begin
      msOut := TMemoryStream.Create;
      TRY
        { Stream out the components data }
        msOut.Position := 0;
        msOut.WriteComponent(btnPressMe);

        { Prepare the CopyData record }
        rCopyDat.dwData:= msOut.Size;
        rCopyDat.cbData:= msOut.Size;
        rCopyDat.lpData:= msOut.Memory;

        { This should return once the message has been processed }
        { Format:  DestinationHandle, Message, SenderHandle, PCOPYDATASTRUCT record }
        SendMessage(hTarget, WM_COPYDATA, Self.Handle, LongInt(@rCopyDat));
      FINALLY
        FreeAndNil(msOut);
      END;
    end else
      ShowMessage('Unable to find the destination window');
end;

end.
